/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2014-04-01 18:14:47 UTC)
 * on 2014-04-07 at 09:18:10 UTC 
 * Modify at your own risk.
 */

package com.jtristan.librosendpoint.entidades.libroendpoint;

/**
 * Service definition for Libroendpoint (v1).
 *
 * <p>
 * This is an API
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link LibroendpointRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Libroendpoint extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    com.google.api.client.util.Preconditions.checkState(
        com.google.api.client.googleapis.GoogleUtils.MAJOR_VERSION == 1 &&
        com.google.api.client.googleapis.GoogleUtils.MINOR_VERSION >= 15,
        "You are currently running with version %s of google-api-client. " +
        "You need at least version 1.15 of google-api-client to run version " +
        "1.16.0-rc of the libroendpoint library.", com.google.api.client.googleapis.GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://grand-landing-460.appspot.com/_ah/api/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "libroendpoint/v1/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   */
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport, which should normally be:
   *        <ul>
   *        <li>Google App Engine:
   *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
   *        <li>Android: {@code newCompatibleTransport} from
   *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
   *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
   *        </li>
   *        </ul>
   * @param jsonFactory JSON factory, which may be:
   *        <ul>
   *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
   *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
   *        <li>Android Honeycomb or higher:
   *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
   *        </ul>
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Libroendpoint(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
      com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
    this(new Builder(transport, jsonFactory, httpRequestInitializer));
  }

  /**
   * @param builder builder
   */
  Libroendpoint(Builder builder) {
    super(builder);
  }

  @Override
  protected void initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * Create a request for the method "getLibro".
   *
   * This request holds the parameters needed by the the libroendpoint server.  After setting any
   * optional parameters, call the {@link GetLibro#execute()} method to invoke the remote operation.
   *
   * @param id
   * @return the request
   */
  public GetLibro getLibro(java.lang.Long id) throws java.io.IOException {
    GetLibro result = new GetLibro(id);
    initialize(result);
    return result;
  }

  public class GetLibro extends LibroendpointRequest<com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro> {

    private static final String REST_PATH = "libro/{id}";

    /**
     * Create a request for the method "getLibro".
     *
     * This request holds the parameters needed by the the libroendpoint server.  After setting any
     * optional parameters, call the {@link GetLibro#execute()} method to invoke the remote operation.
     * <p> {@link
     * GetLibro#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
     * must be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param id
     * @since 1.13
     */
    protected GetLibro(java.lang.Long id) {
      super(Libroendpoint.this, "GET", REST_PATH, null, com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro.class);
      this.id = com.google.api.client.util.Preconditions.checkNotNull(id, "Required parameter id must be specified.");
    }

    @Override
    public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
      return super.executeUsingHead();
    }

    @Override
    public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
      return super.buildHttpRequestUsingHead();
    }

    @Override
    public GetLibro setAlt(java.lang.String alt) {
      return (GetLibro) super.setAlt(alt);
    }

    @Override
    public GetLibro setFields(java.lang.String fields) {
      return (GetLibro) super.setFields(fields);
    }

    @Override
    public GetLibro setKey(java.lang.String key) {
      return (GetLibro) super.setKey(key);
    }

    @Override
    public GetLibro setOauthToken(java.lang.String oauthToken) {
      return (GetLibro) super.setOauthToken(oauthToken);
    }

    @Override
    public GetLibro setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (GetLibro) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public GetLibro setQuotaUser(java.lang.String quotaUser) {
      return (GetLibro) super.setQuotaUser(quotaUser);
    }

    @Override
    public GetLibro setUserIp(java.lang.String userIp) {
      return (GetLibro) super.setUserIp(userIp);
    }

    @com.google.api.client.util.Key
    private java.lang.Long id;

    /**

     */
    public java.lang.Long getId() {
      return id;
    }

    public GetLibro setId(java.lang.Long id) {
      this.id = id;
      return this;
    }

    @Override
    public GetLibro set(String parameterName, Object value) {
      return (GetLibro) super.set(parameterName, value);
    }
  }

  /**
   * Create a request for the method "insertLibro".
   *
   * This request holds the parameters needed by the the libroendpoint server.  After setting any
   * optional parameters, call the {@link InsertLibro#execute()} method to invoke the remote
   * operation.
   *
   * @param content the {@link com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro}
   * @return the request
   */
  public InsertLibro insertLibro(com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro content) throws java.io.IOException {
    InsertLibro result = new InsertLibro(content);
    initialize(result);
    return result;
  }

  public class InsertLibro extends LibroendpointRequest<com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro> {

    private static final String REST_PATH = "libro";

    /**
     * Create a request for the method "insertLibro".
     *
     * This request holds the parameters needed by the the libroendpoint server.  After setting any
     * optional parameters, call the {@link InsertLibro#execute()} method to invoke the remote
     * operation. <p> {@link
     * InsertLibro#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
     * must be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param content the {@link com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro}
     * @since 1.13
     */
    protected InsertLibro(com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro content) {
      super(Libroendpoint.this, "POST", REST_PATH, content, com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro.class);
    }

    @Override
    public InsertLibro setAlt(java.lang.String alt) {
      return (InsertLibro) super.setAlt(alt);
    }

    @Override
    public InsertLibro setFields(java.lang.String fields) {
      return (InsertLibro) super.setFields(fields);
    }

    @Override
    public InsertLibro setKey(java.lang.String key) {
      return (InsertLibro) super.setKey(key);
    }

    @Override
    public InsertLibro setOauthToken(java.lang.String oauthToken) {
      return (InsertLibro) super.setOauthToken(oauthToken);
    }

    @Override
    public InsertLibro setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (InsertLibro) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public InsertLibro setQuotaUser(java.lang.String quotaUser) {
      return (InsertLibro) super.setQuotaUser(quotaUser);
    }

    @Override
    public InsertLibro setUserIp(java.lang.String userIp) {
      return (InsertLibro) super.setUserIp(userIp);
    }

    @Override
    public InsertLibro set(String parameterName, Object value) {
      return (InsertLibro) super.set(parameterName, value);
    }
  }

  /**
   * Create a request for the method "listLibro".
   *
   * This request holds the parameters needed by the the libroendpoint server.  After setting any
   * optional parameters, call the {@link ListLibro#execute()} method to invoke the remote operation.
   *
   * @return the request
   */
  public ListLibro listLibro() throws java.io.IOException {
    ListLibro result = new ListLibro();
    initialize(result);
    return result;
  }

  public class ListLibro extends LibroendpointRequest<com.jtristan.librosendpoint.entidades.libroendpoint.model.CollectionResponseLibro> {

    private static final String REST_PATH = "libro";

    /**
     * Create a request for the method "listLibro".
     *
     * This request holds the parameters needed by the the libroendpoint server.  After setting any
     * optional parameters, call the {@link ListLibro#execute()} method to invoke the remote
     * operation. <p> {@link
     * ListLibro#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
     * must be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @since 1.13
     */
    protected ListLibro() {
      super(Libroendpoint.this, "GET", REST_PATH, null, com.jtristan.librosendpoint.entidades.libroendpoint.model.CollectionResponseLibro.class);
    }

    @Override
    public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
      return super.executeUsingHead();
    }

    @Override
    public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
      return super.buildHttpRequestUsingHead();
    }

    @Override
    public ListLibro setAlt(java.lang.String alt) {
      return (ListLibro) super.setAlt(alt);
    }

    @Override
    public ListLibro setFields(java.lang.String fields) {
      return (ListLibro) super.setFields(fields);
    }

    @Override
    public ListLibro setKey(java.lang.String key) {
      return (ListLibro) super.setKey(key);
    }

    @Override
    public ListLibro setOauthToken(java.lang.String oauthToken) {
      return (ListLibro) super.setOauthToken(oauthToken);
    }

    @Override
    public ListLibro setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (ListLibro) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public ListLibro setQuotaUser(java.lang.String quotaUser) {
      return (ListLibro) super.setQuotaUser(quotaUser);
    }

    @Override
    public ListLibro setUserIp(java.lang.String userIp) {
      return (ListLibro) super.setUserIp(userIp);
    }

    @com.google.api.client.util.Key
    private java.lang.String cursor;

    /**

     */
    public java.lang.String getCursor() {
      return cursor;
    }

    public ListLibro setCursor(java.lang.String cursor) {
      this.cursor = cursor;
      return this;
    }

    @com.google.api.client.util.Key
    private java.lang.Integer limit;

    /**

     */
    public java.lang.Integer getLimit() {
      return limit;
    }

    public ListLibro setLimit(java.lang.Integer limit) {
      this.limit = limit;
      return this;
    }

    @Override
    public ListLibro set(String parameterName, Object value) {
      return (ListLibro) super.set(parameterName, value);
    }
  }

  /**
   * Create a request for the method "removeLibro".
   *
   * This request holds the parameters needed by the the libroendpoint server.  After setting any
   * optional parameters, call the {@link RemoveLibro#execute()} method to invoke the remote
   * operation.
   *
   * @param id
   * @return the request
   */
  public RemoveLibro removeLibro(java.lang.Long id) throws java.io.IOException {
    RemoveLibro result = new RemoveLibro(id);
    initialize(result);
    return result;
  }

  public class RemoveLibro extends LibroendpointRequest<Void> {

    private static final String REST_PATH = "libro/{id}";

    /**
     * Create a request for the method "removeLibro".
     *
     * This request holds the parameters needed by the the libroendpoint server.  After setting any
     * optional parameters, call the {@link RemoveLibro#execute()} method to invoke the remote
     * operation. <p> {@link
     * RemoveLibro#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
     * must be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param id
     * @since 1.13
     */
    protected RemoveLibro(java.lang.Long id) {
      super(Libroendpoint.this, "DELETE", REST_PATH, null, Void.class);
      this.id = com.google.api.client.util.Preconditions.checkNotNull(id, "Required parameter id must be specified.");
    }

    @Override
    public RemoveLibro setAlt(java.lang.String alt) {
      return (RemoveLibro) super.setAlt(alt);
    }

    @Override
    public RemoveLibro setFields(java.lang.String fields) {
      return (RemoveLibro) super.setFields(fields);
    }

    @Override
    public RemoveLibro setKey(java.lang.String key) {
      return (RemoveLibro) super.setKey(key);
    }

    @Override
    public RemoveLibro setOauthToken(java.lang.String oauthToken) {
      return (RemoveLibro) super.setOauthToken(oauthToken);
    }

    @Override
    public RemoveLibro setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (RemoveLibro) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public RemoveLibro setQuotaUser(java.lang.String quotaUser) {
      return (RemoveLibro) super.setQuotaUser(quotaUser);
    }

    @Override
    public RemoveLibro setUserIp(java.lang.String userIp) {
      return (RemoveLibro) super.setUserIp(userIp);
    }

    @com.google.api.client.util.Key
    private java.lang.Long id;

    /**

     */
    public java.lang.Long getId() {
      return id;
    }

    public RemoveLibro setId(java.lang.Long id) {
      this.id = id;
      return this;
    }

    @Override
    public RemoveLibro set(String parameterName, Object value) {
      return (RemoveLibro) super.set(parameterName, value);
    }
  }

  /**
   * Create a request for the method "updateLibro".
   *
   * This request holds the parameters needed by the the libroendpoint server.  After setting any
   * optional parameters, call the {@link UpdateLibro#execute()} method to invoke the remote
   * operation.
   *
   * @param content the {@link com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro}
   * @return the request
   */
  public UpdateLibro updateLibro(com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro content) throws java.io.IOException {
    UpdateLibro result = new UpdateLibro(content);
    initialize(result);
    return result;
  }

  public class UpdateLibro extends LibroendpointRequest<com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro> {

    private static final String REST_PATH = "libro";

    /**
     * Create a request for the method "updateLibro".
     *
     * This request holds the parameters needed by the the libroendpoint server.  After setting any
     * optional parameters, call the {@link UpdateLibro#execute()} method to invoke the remote
     * operation. <p> {@link
     * UpdateLibro#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
     * must be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param content the {@link com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro}
     * @since 1.13
     */
    protected UpdateLibro(com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro content) {
      super(Libroendpoint.this, "PUT", REST_PATH, content, com.jtristan.librosendpoint.entidades.libroendpoint.model.Libro.class);
    }

    @Override
    public UpdateLibro setAlt(java.lang.String alt) {
      return (UpdateLibro) super.setAlt(alt);
    }

    @Override
    public UpdateLibro setFields(java.lang.String fields) {
      return (UpdateLibro) super.setFields(fields);
    }

    @Override
    public UpdateLibro setKey(java.lang.String key) {
      return (UpdateLibro) super.setKey(key);
    }

    @Override
    public UpdateLibro setOauthToken(java.lang.String oauthToken) {
      return (UpdateLibro) super.setOauthToken(oauthToken);
    }

    @Override
    public UpdateLibro setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (UpdateLibro) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public UpdateLibro setQuotaUser(java.lang.String quotaUser) {
      return (UpdateLibro) super.setQuotaUser(quotaUser);
    }

    @Override
    public UpdateLibro setUserIp(java.lang.String userIp) {
      return (UpdateLibro) super.setUserIp(userIp);
    }

    @Override
    public UpdateLibro set(String parameterName, Object value) {
      return (UpdateLibro) super.set(parameterName, value);
    }
  }

  /**
   * Builder for {@link Libroendpoint}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport, which should normally be:
     *        <ul>
     *        <li>Google App Engine:
     *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
     *        <li>Android: {@code newCompatibleTransport} from
     *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
     *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
     *        </li>
     *        </ul>
     * @param jsonFactory JSON factory, which may be:
     *        <ul>
     *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
     *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
     *        <li>Android Honeycomb or higher:
     *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
     *        </ul>
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
        com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Libroendpoint}. */
    @Override
    public Libroendpoint build() {
      return new Libroendpoint(this);
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    @Override
    public Builder setSuppressRequiredParameterChecks(boolean suppressRequiredParameterChecks) {
      return (Builder) super.setSuppressRequiredParameterChecks(suppressRequiredParameterChecks);
    }

    @Override
    public Builder setSuppressAllChecks(boolean suppressAllChecks) {
      return (Builder) super.setSuppressAllChecks(suppressAllChecks);
    }

    /**
     * Set the {@link LibroendpointRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setLibroendpointRequestInitializer(
        LibroendpointRequestInitializer libroendpointRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(libroendpointRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        com.google.api.client.googleapis.services.GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
